"use strict";

const path = require("path");
const bluebird_1 = require("bluebird");
const awaiter_1 = require("./awaiter");
const linux_1 = require("../lib/linux");
const platformPackager_1 = require("./platformPackager");
const __awaiter = awaiter_1.tsAwaiter;
Array.isArray(__awaiter);
const buildDeb = bluebird_1.Promise.promisify(linux_1.init().build);
class LinuxPackager extends platformPackager_1.PlatformPackager {
    constructor(info) {
        super(info);
    }
    getBuildConfigurationKey() {
        return "linux";
    }
    packageInDistributableFormat(outDir, customConfiguration, arch) {
        const specification = {
            version: this.metadata.version,
            title: this.metadata.name,
            comment: this.metadata.description,
            maintainer: this.metadata.author,
            arch: arch === "ia32" ? 32 : 64,
            target: "deb",
            executable: this.metadata.name
        };
        if (customConfiguration != null) {
            Object.assign(specification, customConfiguration);
        }
        return buildDeb({
            log: function emptyLog() {},
            appPath: outDir,
            out: path.dirname(outDir),
            config: {
                linux: specification
            }
        }).then(it => this.dispatchArtifactCreated(it));
    }
}
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = LinuxPackager;
//# sourceMappingURL=linuxPackager.js.map
